
;VLA Solid Bounding Box


;;;;;;returns bounding box as 2 points
(defun vbbox ( objid / minb maxb)
  
 (if (= (type objid) 'ENAME) ; if ENAME is passed convert to VLAobject
    (setq objid (vlax-ename->vla-object objid)) 
    )
	(vla-GetBoundingBox objid 'minb 'maxb)
	(setq minb (vlax-safearray->list minb)
	      maxb (vlax-safearray->list maxb)
        )
	(list minb maxb)
)

;;;;;;returns bounding box as 3 distances L W H
(defun vbboxLWH ( objid / minb maxb)
  
 (if (= (type objid) 'ENAME) ; if ENAME is passed convert to VLAobject
    (setq objid (vlax-ename->vla-object objid)) 
    )
	(vla-GetBoundingBox objid 'minb 'maxb)
	(setq minb (vlax-safearray->list minb)
	      maxb (vlax-safearray->list maxb)
        )
	(mapcar '-  maxb minb)
)

;;;;;;returns a list of bounding boxes as 3 distances L W H
(defun c:bbList ( / ss lis )
  
  (foreach m (LM:ss->ent(setq ss (ssget)))
    (setq lis (cons (vbboxLWH m) lis))
  )
  lis
)

(defun c:GetBBox (/ bb)
  (setvar "OSMODE" 16384)
  (setvar "CMDECHO" 0)
  (setq bb (vbbox (car (entsel))))
  (if (equal (caddr (car bb)) (caddr (cadr bb)) 0.0001)
    (vl-cmdf "_.RECTANGLE" (car bb) (cadr bb))
    (vl-cmdf "_.BOX" (car bb) (cadr bb))
    )
   )

(defun c:GetBBoxM (/ sel c bb)
  (setvar "OSMODE" 16384)
  (setvar "CMDECHO" 0)
  (setq sel (LM:ss->ent (ssget ))
	c 0
	)
  (foreach m sel
    (setq bb (vbbox m)
	  c  (1+ c)
	  )
    (if (equal (caddr (car bb)) (caddr (cadr bb)) 0.0001)
      (vl-cmdf "_.RECTANGLE" (car bb) (cadr bb))
      (vl-cmdf "_.BOX" (car bb) (cadr bb))
      );if
    );for
  c
  )


;;--------------=={ SelectionSet -> Entities }==--------------;;
;;                                                            ;;
;;  Converts a SelectionSet to a list of Entities             ;;
;;------------------------------------------------------------;;
;;  Author: Lee Mac, Copyright  2011 - www.lee-mac.com       ;;
;;------------------------------------------------------------;;
;;  Arguments:                                                ;;
;;  ss - Valid SelectionSet (Pickset)                         ;;
;;------------------------------------------------------------;;
;;  Returns:  List of Entity names, else nil                  ;;
;;------------------------------------------------------------;;

(defun LM:ss->ent ( ss / i l )
    (if ss
        (repeat (setq i (sslength ss))
            (setq l (cons (ssname ss (setq i (1- i))) l))
        )
    )
)

